#!/bin/sh
set -e

# Location auf a sshd_config with "PermitRootLogin no" and
# "PasswordAuthentication no".
config_tree_prefix="${HOME}/public_repos/config/buster"
linkable_files_dir="${config_tree_prefix}/etc_files/server"
system_path_sshd_config='/etc/ssh/sshd_config'
local_path_sshd_config="${linkable_files_dir}${system_path_sshd_config}"

# Ensure we have a server name as argument.
if [ $# -eq 0 ]; then
    echo "Need server as argument."
    false
fi
server="$1"

# So we're only asked once …
eval $(ssh-agent)
ssh-add

# This will be used to log-in as root from plom account.
echo 'Asking for new root password.'
ssh root@"${server}" "passwd"

# Set up plom's ~/.ssh/authorized_keys from root's.
ssh root@"${server}" 'useradd -m plom'
ssh root@"${server}" 'mkdir /home/plom/.ssh'
ssh root@"${server}" 'chown plom:plom /home/plom/.ssh'
ssh root@"${server}" 'cp /root/.ssh/authorized_keys /home/plom/.ssh/'
ssh root@"${server}" 'chown plom:plom /home/plom/.ssh/authorized_keys'

# Set up SSH config and remove direct SSH login to root.
scp "${local_path_sshd_config}" root@"${server}":"${system_path_sshd_config}"
ssh root@"${server}" 'rm -rf /root/.ssh && service ssh restart'
